#!/bin/bash

#######################
# Set likely PATH to find node
PATH="$PATH:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin:/opt/sbin:/opt/local/bin:/opt/local/sbin"

#######################
# Change into the resources directory
THEDIR=`dirname "$BASH_SOURCE"`
THEDIR=$THEDIR/cadet-resources
cd $THEDIR

#######################
# Find node executable
nodePath=$(which node)
if [ -z "$nodePath" ]
then
echo nodePath=[$nodePath]
echo "install it"
osascript -e 'tell app "System Events" to display dialog "To run CADET, please install NodeJS.\r\rExiting..."'
exit
fi

#######################
# Start node with cadet-server, and a likely file browsing path (home directory)
# Starting in background so terminal window can close
echo Found node at nodePath=[$nodePath]
echo Starting cadet-server with node...
"$nodePath" cadet-server.js --dir ~ > /dev/null 2>&1 &

exit 0